CPPFLAGS += -DGOT_LIBEXECDIR=${LIBEXECDIR} -DGOT_VERSION=${GOT_VERSION}
#CFLAGS += -DGOT_PACK_NO_MMAP
#CFLAGS += -DGOT_NO_OBJ_CACHE
#CFLAGS += -DGOT_OBJ_CACHE_DEBUG
#CFLAGS += -DGOT_DIFF_NO_MMAP

# work around https://gcc.gnu.org/bugzilla/show_bug.cgi?id=63567
#.include <bsd.compiler.mk>
#.if ${COMPILER_TYPE} == "gcc" && ${COMPILER_VERSION} < 50000
#CSTD = gnu89
#.endif

OPENBSD_COMPAT := ${.PARSEDIR}/openbsd-compat
CFLAGS += ${CPPFLAGS} -I${OPENBSD_COMPAT}
CFLAGS += -Wno-pointer-sign

LDFLAGS += -L${OPENBSD_COMPAT}
LDADD += -lopenbsd-compat #-lmd

.if "${GOT_RELEASE}" == "Yes"
PREFIX ?= /usr/local
BINDIR ?= ${PREFIX}/bin
LIBEXECDIR ?= ${PREFIX}/libexec
MANDIR ?= ${PREFIX}/man/man
.else
CFLAGS += -Werror -Wall -Wstrict-prototypes -Wunused-variable
PREFIX ?= ${HOME}
BINDIR ?= ${PREFIX}/bin
LIBEXECDIR ?= ${BINDIR}

BINOWN ?= ${USER}
.if !defined(BINGRP)
BINGRP != id -g -n
.endif

.if defined(PROFILE)
CPPFLAGS += -DPROFILE
DEBUG = -O0 -pg -g -static
.else
DEBUG = -O0 -g
.endif

.endif
